javax.jms

## Interface QueueSender

- All Superinterfaces:
    AutoCloseable, MessageProducer

      public interface QueueSender
      extends MessageProducer

  A client uses a `QueueSender` object to send messages to a queue.

  Normally, the `Queue` is specified when a `QueueSender` is created. In this case, an attempt to use the `send` methods for an unidentified `QueueSender` will throw a `java.lang.UnsupportedOperationException`.

  If the `QueueSender` is created with an unidentified `Queue`, an attempt to use the `send` methods that assume that the `Queue` has been identified will throw a `java.lang.UnsupportedOperationException`.

  During the execution of its `send` method, a message must not be changed by other threads within the client. If the message is modified, the result of the `send` is undefined.

  After sending a message, a client may retain and modify it without affecting the message that has been sent. The same message object may be sent multiple times.

  The following message headers are set as part of sending a message: `JMSDestination`, `JMSDeliveryMode`, `JMSExpiration`, `JMSPriority`, `JMSMessageID` and `JMSTimeStamp`. When the message is sent, the values of these headers are ignored. After the completion of the `send`, the headers hold the values specified by the method sending the message. It is possible for the `send` method not to set `JMSMessageID` and `JMSTimeStamp` if the setting of these headers is explicitly disabled by the `MessageProducer.setDisableMessageID` or `MessageProducer.setDisableMessageTimestamp` method.

  Creating a `MessageProducer` provides the same features as creating a `QueueSender`. A `MessageProducer` object is recommended when creating new code. The `QueueSender` is provided to support existing code.

  Since:
    JMS 1.0
  See Also:
    `MessageProducer`, `Session.createProducer(Destination)`, `QueueSession.createSender(Queue)`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Queue` | `getQueue()` Gets the queue associated with this `QueueSender`.
    `void` | `send(Message message)` Sends a message to the queue.
    `void` | `send(Message message, int deliveryMode, int priority, long timeToLive)` Sends a message to the queue, specifying delivery mode, priority, and time to live.
    `void` | `send(Queue queue, Message message)` Sends a message to a queue for an unidentified message producer.
    `void` | `send(Queue queue, Message message, int deliveryMode, int priority, long timeToLive)` Sends a message to a queue for an unidentified message producer, specifying delivery mode, priority and time to live.

    - ### Methods inherited from interface javax.jms.MessageProducer

      `close, getDeliveryDelay, getDeliveryMode, getDestination, getDisableMessageID, getDisableMessageTimestamp, getPriority, getTimeToLive, send, send, send, send, send, send, setDeliveryDelay, setDeliveryMode, setDisableMessageID, setDisableMessageTimestamp, setPriority, setTimeToLive`

- - ### Method Detail

    - #### getQueue

          Queue getQueue()
                         throws JMSException

      Gets the queue associated with this `QueueSender`.
      Returns:
        this sender's queue
      Throws:
        `JMSException` - if the JMS provider fails to get the queue for this `QueueSender` due to some internal error.

    - #### send

          void send(Message message)
                    throws JMSException

      Sends a message to the queue. Uses the `QueueSender`'s default delivery mode, priority, and time to live.
      Specified by:
        `send` in interface `MessageProducer`
      Parameters:
        `message` - the message to send
      Throws:
        `JMSException` - if the JMS provider fails to send the message due to some internal error.
        `MessageFormatException` - if an invalid message is specified.
        `InvalidDestinationException` - if a client uses this method with a `QueueSender` with an invalid queue.
        `UnsupportedOperationException` - if a client uses this method with a `QueueSender` that did not specify a queue at creation time.
      See Also:
        `MessageProducer.getDeliveryMode()`, `MessageProducer.getTimeToLive()`, `MessageProducer.getPriority()`

    - #### send

          void send(Message message,
                  int deliveryMode,
                  int priority,
                  long timeToLive)
                    throws JMSException

      Sends a message to the queue, specifying delivery mode, priority, and time to live.
      Specified by:
        `send` in interface `MessageProducer`
      Parameters:
        `message` - the message to send
        `deliveryMode` - the delivery mode to use
        `priority` - the priority for this message
        `timeToLive` - the message's lifetime (in milliseconds)
      Throws:
        `JMSException` - if the JMS provider fails to send the message due to some internal error.
        `MessageFormatException` - if an invalid message is specified.
        `InvalidDestinationException` - if a client uses this method with a `QueueSender` with an invalid queue.
        `UnsupportedOperationException` - if a client uses this method with a `QueueSender` that did not specify a queue at creation time.
      See Also:
        `Session.createProducer(javax.jms.Destination)`

    - #### send

          void send(Queue queue,
                  Message message)
                    throws JMSException

      Sends a message to a queue for an unidentified message producer. Uses the `QueueSender`'s default delivery mode, priority, and time to live.

      Typically, a message producer is assigned a queue at creation time; however, the JMS API also supports unidentified message producers, which require that the queue be supplied every time a message is sent.

      Parameters:
        `queue` - the queue to send this message to
        `message` - the message to send
      Throws:
        `JMSException` - if the JMS provider fails to send the message due to some internal error.
        `MessageFormatException` - if an invalid message is specified.
        `InvalidDestinationException` - if a client uses this method with an invalid queue.
      See Also:
        `MessageProducer.getDeliveryMode()`, `MessageProducer.getTimeToLive()`, `MessageProducer.getPriority()`

    - #### send

          void send(Queue queue,
                  Message message,
                  int deliveryMode,
                  int priority,
                  long timeToLive)
                    throws JMSException

      Sends a message to a queue for an unidentified message producer, specifying delivery mode, priority and time to live.

      Typically, a message producer is assigned a queue at creation time; however, the JMS API also supports unidentified message producers, which require that the queue be supplied every time a message is sent.

      Parameters:
        `queue` - the queue to send this message to
        `message` - the message to send
        `deliveryMode` - the delivery mode to use
        `priority` - the priority for this message
        `timeToLive` - the message's lifetime (in milliseconds)
      Throws:
        `JMSException` - if the JMS provider fails to send the message due to some internal error.
        `MessageFormatException` - if an invalid message is specified.
        `InvalidDestinationException` - if a client uses this method with an invalid queue.

Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.